#require.paths.unshift(__dirname + "/../node_modules")
vows = require('vows')
assert = require('assert')
hoard = require("src/hoard")
sys = require('sys')

# FIXME: Test test2.whisper as well
FILENAME = 'spec/test2.whisper'
TIMESTAMP = 1312239932

vows.describe('Hoard').addBatch
    'can read a Whisper file with info() and parse':
        topic: -> hoard.info FILENAME, @callback
        'maxRetention': (err, header) -> assert.equal 36000, header.maxRetention
        'xFilesFactor': (err, header) -> assert.equal 0.5, header.xFilesFactor
        'number of archives': (err, header) -> assert.equal 2, header.archives.length
        'first archive':
            topic: (header) -> header.archives[0]
            'retention': (err, archive) -> assert.equal 600, archive.retention
            'secondsPerPoint': (err, archive) -> assert.equal 1, archive.secondsPerPoint
            'points': (err, archive) -> assert.equal 600, archive.points
            'size': (err, archive) -> assert.equal 7200, archive.size
            'offset': (err, archive) -> assert.equal 40, archive.offset
        'second archive':
            topic: (header) -> header.archives[1]
            'retention': (err, archive) -> assert.equal 36000, archive.retention
            'secondsPerPoint': (err, archive) -> assert.equal 10, archive.secondsPerPoint
            'points': (err, archive) -> assert.equal 3600, archive.points
            'size': (err, archive) -> assert.equal 43200, archive.size
            'offset': (err, archive) -> assert.equal 7240, archive.offset

    'can read a Whisper file with fetch() and parse':
        #topic: -> hoard.fetch FILENAME, TIMESTAMP - 100, TIMESTAMP, @callback
        'info': (err, timeInfo, values) ->
            console.log 'TIMEINFO', timeInfo
            #console.log 'VALUES', values


            #assert.equal 36000, header.maxRetention
        #'xFilesFactor': (err, header) -> assert.equal 0.5, header.xFilesFactor
        #'number of archives': (err, header) -> assert.equal 2, header.archives.length
    #


.export module
