fs = require('fs')
Buffer = require('buffer').Buffer
Binary = require('binary')
pack = require('jspack').jspack

#longFormat = "!L"
#floatFormat = "!f"
#timestampFormat = "!L"
#valueFormat = "!d"
#pointFormat = "!Ld"
#metadataFormat = "!2LfL"
#archiveInfoFormat = "!3L"

# FIXME: Determine this in a better way
POINT_SIZE = 4 + 8 # long, double

unixTime = -> parseInt(new Date().getTime() / 1000)

create = (path, archiveList, xFilesFactor=0.5) ->
    123

update = (path, value, timestamp=null) ->
    123

updateMany = (path, points) ->
    123

info = (path, cb) ->
    # FIXME: Close this stream?
    # FIXME: Signal errors to callback?
    file = fs.createReadStream(path)
    archives = []; metadata = {}
    Binary.stream(file)
        .word32bu('lastUpdate')
        .word32bu('maxRetention')
        .buffer('xff', 4) # Must decode separately since node-binary can't handle floats
        .word32bu('archiveCount')
        .tap (vars) ->
            metadata = vars
            metadata.xff = pack.Unpack('!f', vars.xff, 0)[0]
            @flush()
            for index in [0...metadata.archiveCount]
                @word32bu('offset').word32bu('secondsPerPoint').word32bu('points')
                @tap (archive) ->
                    @flush()
                    archive.retention = archive.secondsPerPoint * archive.points
                    archive.size = archive.points * POINT_SIZE
                    archives.push(archive)
        .tap ->
            cb null,
                maxRetention: metadata.maxRetention
                xFilesFactor: metadata.xff
                archives: archives

fetch = (path, from, to, cb) ->
    info path, (err, header) ->
        now = unixTime()
        oldestTime = now - header.maxRetention
        console.log("form", from, to)
        from = oldestTime if from < oldestTime
        throw new Error('Invalid time interval') unless from < to
        to = now if to > now or to < from
        diff = now - from
        fd = null

        # Find closest archive to look in, that iwll contain our information
        for archive in header.archives
            break if archive.retention >= diff

        fromInterval = parseInt(from - (from % archive.secondsPerPoint)) + archive.secondsPerPoint
        toInterval = parseInt(to - (to % archive.secondsPerPoint)) + archive.secondsPerPoint

        file = fs.createReadStream(path)

        Binary.stream(file)
            .skip(archive.offset)
            .word32bu('baseInterval')
            .word32bu('baseValue')
            .tap (vars) ->
                console.log("VARS", vars)
                if vars.baseInterval == 0
                    # Nothing has been written to this hoard
                    step = archive.secondsPerPoint
                    points = (toInterval - fromInterval) / step
                    timeInfo = [fromInterval, toInterval, step]
                    values = (null for n in [0...points])
                    cb(null, timeInfo, values)
                else
                    # We have data in this hoard, let's read it
                    getOffset = (interval) ->
                        timeDistance = interval - vars.baseInterval
                        pointDistance = timeDistance / archive.secondsPerPoint
                        byteDistance = pointDistance * POINT_SIZE
                        archive.offset + (byteDistance % archive.size)

                    fromOffset = getOffset(fromInterval)
                    toOffset = getOffset(toInterval)

                    fs.open path, 'r', (err, fd) ->
                        if err then throw err
                        if fromOffset < toOffset
                            # We don't wrap around, can everything in a single read
                            size = toOffset - fromOffset
                            seriesBuffer = new Buffer(size)
                            fs.read fd, seriesBuffer, 0, size, fromOffset, (err, num) ->
                                # FIXME: Handle error
                                unpack(seriesBuffer) # We have read it, go unpack!
                                fs.close(fd)
                        else
                            # We wrap around the archive, we need two reads
                            archiveEnd = archive.offset + archive.size
                            size1 = archiveEnd - fromOffset
                            size2 = untilOffset - archive.offset
                            seriesBuffer = new Buffer(size1 + size2)
                            fs.read fd, seriesBuffer, 0, size1, fromOffset, (err, num) ->
                                # FIXME: Handle error
                                fs.read fd, seriesBuffer, size1, size2, archive.offset, (err, num) ->
                                    # FIXME: Handle error
                                    unpack(seriesBuffer) # We have read it, go unpack!
                                    fs.close(fd)

        unpack = (seriesData) ->
            # Optmize this?
            numPoints = seriesData.length / POINT_SIZE
            seriesFormat = "!" + ('Ld' for f in [0...numPoints]).join("")
            unpackedSeries = pack.Unpack(seriesFormat, seriesData, 0)

            console.log("NUM POINTS", numPoints)
            valueList = [] # Use buffer/pre-allocate?
            currentInterval = fromInterval
            step = archive.secondsPerPoint

            for i in [0...unpackedSeries.length] by 2
                pointTime = unpackedSeries[i]
                if pointTime == currentInterval
                    pointValue = unpackedSeries[i + 1]
                    valueList.push(pointValue)
                currentInterval += step

            timeInfo = [fromInterval, toInterval, step]
            cb(null, timeInfo, valueList)

exports.create = create
exports.update = update
exports.updateMany = updateMany
exports.info = info
exports.fetch = fetch